#ifndef _3D_H_
#define _3D_H_

#include "buffer.h"

#define OFFSET 10.0

//For all these functions :
//size should be the number of vertices of a mesh
//vertices should be a table of size 3*size    {x1,y1,z1, x2,y2,z2,...}
//pos should be a table of size 2*size       {x1,y1, x2,y2,...}

//calculates the position of given vertices on the screen. The position is stored in pos.
void computeVertices(double *vertices,int *pos,int size);

//translates vertices
void translate(double *vertices,int size,double x,double y,double z);

//scales vertices
void scale(double *vertices,int size,double x,double y,double z);

//rotates vertices
void rotateX(double *vertices,int size,double angle);
void rotateY(double *vertices,int size,double angle);
void rotateZ(double *vertices,int size,double angle);

//multiply a matrix and a vector
void multiplyMatrix(double *vector,double *matrix);

#endif
